diff -U 3 -dHrN -- silent/Makefile nosilent/Makefile
--- silent/Makefile	2013-09-05 17:11:57.000000000 +0400
+++ nosilent/Makefile	2013-09-05 17:14:21.000000000 +0400
@@ -1,6 +1,6 @@
 #############################################################################
 # Makefile for building: Untitled
-# Generated by qmake (3.0) (Qt 5.1.1) on: ?? 5. ??? 17:11:56 2013
+# Generated by qmake (3.0) (Qt 5.1.1) on: ?? 5. ??? 17:14:21 2013
 # Project:  ../Untitled/Untitled.pro
 # Template: app
 # Command: C:/Qt/5.1.1/mingw48_32/bin/qmake.exe -spec win32-g++ CONFIG+=debug CONFIG+=declarative_debug CONFIG+=qml_debug -o Makefile ../Untitled/Untitled.pro
@@ -125,7 +125,6 @@
 		C:/Qt/5.1.1/mingw48_32/mkspecs/features/exceptions.prf \
 		C:/Qt/5.1.1/mingw48_32/mkspecs/features/yacc.prf \
 		C:/Qt/5.1.1/mingw48_32/mkspecs/features/lex.prf \
-		C:/Qt/5.1.1/mingw48_32/mkspecs/features/silent.prf \
 		../Untitled/Untitled.pro \
 		C:/Qt/5.1.1/mingw48_32/lib/Qt5Widgets.prl \
 		C:/Qt/5.1.1/mingw48_32/lib/Qt5Gui.prl \
@@ -197,7 +196,6 @@
 C:/Qt/5.1.1/mingw48_32/mkspecs/features/exceptions.prf:
 C:/Qt/5.1.1/mingw48_32/mkspecs/features/yacc.prf:
 C:/Qt/5.1.1/mingw48_32/mkspecs/features/lex.prf:
-C:/Qt/5.1.1/mingw48_32/mkspecs/features/silent.prf:
 ../Untitled/Untitled.pro:
 C:/Qt/5.1.1/mingw48_32/lib/Qt5Widgets.prl:
 C:/Qt/5.1.1/mingw48_32/lib/Qt5Gui.prl:
diff -U 3 -dHrN -- silent/Makefile.Debug nosilent/Makefile.Debug
--- silent/Makefile.Debug	2013-09-05 17:11:57.000000000 +0400
+++ nosilent/Makefile.Debug	2013-09-05 17:14:21.000000000 +0400
@@ -1,6 +1,6 @@
 #############################################################################
 # Makefile for building: Untitled
-# Generated by qmake (3.0) (Qt 5.1.1) on: ?? 5. ??? 17:11:56 2013
+# Generated by qmake (3.0) (Qt 5.1.1) on: ?? 5. ??? 17:14:20 2013
 # Project:  ../Untitled/Untitled.pro
 # Template: app
 #############################################################################
@@ -9,13 +9,13 @@
 
 ####### Compiler, tools and options
 
-CC            = @echo compiling $< && gcc
-CXX           = @echo compiling $< && g++
+CC            = gcc
+CXX           = g++
 DEFINES       = -DUNICODE -DQT_QML_DEBUG -DQT_DECLARATIVE_DEBUG -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB -DQT_NEEDS_QMAIN
 CFLAGS        = -pipe -fno-keep-inline-dllexport -g -Wall -Wextra $(DEFINES)
 CXXFLAGS      = -pipe -fno-keep-inline-dllexport -g -frtti -Wall -Wextra -fexceptions -mthreads $(DEFINES)
 INCPATH       = -I../Untitled -I'C:/Qt/5.1.1/mingw48_32/include' -I'C:/Qt/5.1.1/mingw48_32/include/QtWidgets' -I'C:/Qt/5.1.1/mingw48_32/include/QtGui' -I'C:/Qt/5.1.1/mingw48_32/include/QtCore' -I'debug' -I'.' -I'.' -I'C:/Qt/5.1.1/mingw48_32/mkspecs/win32-g++'
-LINKER      =        @echo linking $@ && g++
+LINKER      =        g++
 LFLAGS        =        -Wl,-subsystem,windows -mthreads
 LIBS        =        -lglu32 -lopengl32 -lgdi32 -luser32 -lmingw32 -lqtmaind -LC:\Qt\5.1.1\mingw48_32\lib -lQt5Widgetsd -lQt5Guid -lQt5Cored 
 QMAKE         = C:/Qt/5.1.1/mingw48_32/bin/qmake.exe
@@ -85,7 +85,7 @@
 qmake_all: FORCE
 
 dist:
-	$(ZIP) Untitled.zip $(SOURCES) $(DIST) ../Untitled/Untitled.pro C:/Qt/5.1.1/mingw48_32/mkspecs/features/spec_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/qdevice.pri C:/Qt/5.1.1/mingw48_32/mkspecs/features/device_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/common/shell-unix.conf C:/Qt/5.1.1/mingw48_32/mkspecs/qconfig.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axbase.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axcontainer.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axserver.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_clucene.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_concurrent.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_core.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_declarative.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_designer.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_designercomponents.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_gui.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_help.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_multimedia.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_multimediawidgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_network.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_opengl.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_openglextensions.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_platformsupport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_printsupport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qml.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qmldevtools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qmltest.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qtmultimediaquicktools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_quick.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_quickparticles.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_script.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_scripttools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_sensors.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_serialport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_sql.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_svg.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_testlib.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_uitools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_v8.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_webkit.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_webkitwidgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_widgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_xml.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_xmlpatterns.pri C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt_functions.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/win32-g++/qmake.conf C:/Qt/5.1.1/mingw48_32/mkspecs/features/spec_post.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/exclusive_builds.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/default_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/default_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/resolve_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/default_post.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/build_pass.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qml_debug.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/declarative_debug.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/rtti.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/warn_on.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/resources.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/moc.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/opengl.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/uic.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/windows.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/testcase_targets.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/exceptions.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/yacc.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/lex.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/silent.prf ../Untitled/Untitled.pro C:/Qt/5.1.1/mingw48_32/lib/Qt5Widgetsd.prl C:/Qt/5.1.1/mingw48_32/lib/Qt5Guid.prl C:/Qt/5.1.1/mingw48_32/lib/Qt5Cored.prl  RESOURCES HEADERS SOURCES OBJECTIVE_SOURCES FORMS YACCSOURCES YACCSOURCES LEXSOURCES 
+	$(ZIP) Untitled.zip $(SOURCES) $(DIST) ../Untitled/Untitled.pro C:/Qt/5.1.1/mingw48_32/mkspecs/features/spec_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/qdevice.pri C:/Qt/5.1.1/mingw48_32/mkspecs/features/device_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/common/shell-unix.conf C:/Qt/5.1.1/mingw48_32/mkspecs/qconfig.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axbase.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axcontainer.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axserver.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_clucene.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_concurrent.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_core.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_declarative.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_designer.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_designercomponents.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_gui.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_help.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_multimedia.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_multimediawidgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_network.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_opengl.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_openglextensions.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_platformsupport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_printsupport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qml.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qmldevtools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qmltest.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qtmultimediaquicktools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_quick.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_quickparticles.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_script.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_scripttools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_sensors.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_serialport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_sql.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_svg.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_testlib.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_uitools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_v8.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_webkit.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_webkitwidgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_widgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_xml.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_xmlpatterns.pri C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt_functions.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/win32-g++/qmake.conf C:/Qt/5.1.1/mingw48_32/mkspecs/features/spec_post.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/exclusive_builds.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/default_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/default_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/resolve_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/default_post.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/build_pass.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qml_debug.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/declarative_debug.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/rtti.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/warn_on.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/resources.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/moc.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/opengl.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/uic.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/windows.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/testcase_targets.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/exceptions.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/yacc.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/lex.prf ../Untitled/Untitled.pro C:/Qt/5.1.1/mingw48_32/lib/Qt5Widgetsd.prl C:/Qt/5.1.1/mingw48_32/lib/Qt5Guid.prl C:/Qt/5.1.1/mingw48_32/lib/Qt5Cored.prl  RESOURCES HEADERS SOURCES OBJECTIVE_SOURCES FORMS YACCSOURCES YACCSOURCES LEXSOURCES 
 
 clean: compiler_clean 
 	-$(DEL_FILE) debug/main.o debug/mainwindow.o debug/moc_mainwindow.o
@@ -217,7 +217,7 @@
 		C:/Qt/5.1.1/mingw48_32/include/QtWidgets/qtabwidget.h \
 		C:/Qt/5.1.1/mingw48_32/include/QtGui/qicon.h \
 		../Untitled/mainwindow.h
-	@echo moc ../Untitled/mainwindow.h && C:/Qt/5.1.1/mingw48_32/bin/moc.exe $(DEFINES) -D__GNUC__ -DWIN32 $(INCPATH) ../Untitled/mainwindow.h -o debug/moc_mainwindow.cpp
+	C:/Qt/5.1.1/mingw48_32/bin/moc.exe $(DEFINES) -D__GNUC__ -DWIN32 $(INCPATH) ../Untitled/mainwindow.h -o debug/moc_mainwindow.cpp
 
 compiler_moc_source_make_all:
 compiler_moc_source_clean:
@@ -225,7 +225,7 @@
 compiler_uic_clean:
 	-$(DEL_FILE) ui_mainwindow.h
 ui_mainwindow.h: ../Untitled/mainwindow.ui
-	@echo uic ../Untitled/mainwindow.ui && C:/Qt/5.1.1/mingw48_32/bin/uic.exe ../Untitled/mainwindow.ui -o ui_mainwindow.h
+	C:/Qt/5.1.1/mingw48_32/bin/uic.exe ../Untitled/mainwindow.ui -o ui_mainwindow.h
 
 compiler_yacc_decl_make_all:
 compiler_yacc_decl_clean:
diff -U 3 -dHrN -- silent/Makefile.Release nosilent/Makefile.Release
--- silent/Makefile.Release	2013-09-05 17:11:57.000000000 +0400
+++ nosilent/Makefile.Release	2013-09-05 17:14:21.000000000 +0400
@@ -1,6 +1,6 @@
 #############################################################################
 # Makefile for building: Untitled
-# Generated by qmake (3.0) (Qt 5.1.1) on: ?? 5. ??? 17:11:56 2013
+# Generated by qmake (3.0) (Qt 5.1.1) on: ?? 5. ??? 17:14:20 2013
 # Project:  ../Untitled/Untitled.pro
 # Template: app
 #############################################################################
@@ -9,13 +9,13 @@
 
 ####### Compiler, tools and options
 
-CC            = @echo compiling $< && gcc
-CXX           = @echo compiling $< && g++
+CC            = gcc
+CXX           = g++
 DEFINES       = -DUNICODE -DQT_QML_DEBUG -DQT_DECLARATIVE_DEBUG -DQT_NO_DEBUG -DQT_WIDGETS_LIB -DQT_GUI_LIB -DQT_CORE_LIB -DQT_NEEDS_QMAIN
 CFLAGS        = -pipe -fno-keep-inline-dllexport -O2 -Wall -Wextra $(DEFINES)
 CXXFLAGS      = -pipe -fno-keep-inline-dllexport -O2 -frtti -Wall -Wextra -fexceptions -mthreads $(DEFINES)
 INCPATH       = -I../Untitled -I'C:/Qt/5.1.1/mingw48_32/include' -I'C:/Qt/5.1.1/mingw48_32/include/QtWidgets' -I'C:/Qt/5.1.1/mingw48_32/include/QtGui' -I'C:/Qt/5.1.1/mingw48_32/include/QtCore' -I'release' -I'.' -I'.' -I'C:/Qt/5.1.1/mingw48_32/mkspecs/win32-g++'
-LINKER      =        @echo linking $@ && g++
+LINKER      =        g++
 LFLAGS        =        -Wl,-s -Wl,-subsystem,windows -mthreads
 LIBS        =        -lglu32 -lopengl32 -lgdi32 -luser32 -lmingw32 -lqtmain -LC:\Qt\5.1.1\mingw48_32\lib -lQt5Widgets -lQt5Gui -lQt5Core 
 QMAKE         = C:/Qt/5.1.1/mingw48_32/bin/qmake.exe
@@ -85,7 +85,7 @@
 qmake_all: FORCE
 
 dist:
-	$(ZIP) Untitled.zip $(SOURCES) $(DIST) ../Untitled/Untitled.pro C:/Qt/5.1.1/mingw48_32/mkspecs/features/spec_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/qdevice.pri C:/Qt/5.1.1/mingw48_32/mkspecs/features/device_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/common/shell-unix.conf C:/Qt/5.1.1/mingw48_32/mkspecs/qconfig.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axbase.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axcontainer.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axserver.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_clucene.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_concurrent.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_core.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_declarative.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_designer.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_designercomponents.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_gui.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_help.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_multimedia.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_multimediawidgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_network.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_opengl.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_openglextensions.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_platformsupport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_printsupport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qml.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qmldevtools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qmltest.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qtmultimediaquicktools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_quick.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_quickparticles.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_script.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_scripttools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_sensors.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_serialport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_sql.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_svg.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_testlib.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_uitools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_v8.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_webkit.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_webkitwidgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_widgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_xml.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_xmlpatterns.pri C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt_functions.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/win32-g++/qmake.conf C:/Qt/5.1.1/mingw48_32/mkspecs/features/spec_post.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/exclusive_builds.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/default_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/default_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/resolve_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/default_post.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/build_pass.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qml_debug.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/declarative_debug.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/rtti.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/warn_on.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/resources.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/moc.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/opengl.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/uic.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/windows.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/testcase_targets.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/exceptions.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/yacc.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/lex.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/silent.prf ../Untitled/Untitled.pro C:/Qt/5.1.1/mingw48_32/lib/Qt5Widgets.prl C:/Qt/5.1.1/mingw48_32/lib/Qt5Gui.prl C:/Qt/5.1.1/mingw48_32/lib/Qt5Core.prl  RESOURCES HEADERS SOURCES OBJECTIVE_SOURCES FORMS YACCSOURCES YACCSOURCES LEXSOURCES 
+	$(ZIP) Untitled.zip $(SOURCES) $(DIST) ../Untitled/Untitled.pro C:/Qt/5.1.1/mingw48_32/mkspecs/features/spec_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/qdevice.pri C:/Qt/5.1.1/mingw48_32/mkspecs/features/device_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/common/shell-unix.conf C:/Qt/5.1.1/mingw48_32/mkspecs/qconfig.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axbase.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axcontainer.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_axserver.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_clucene.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_concurrent.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_core.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_declarative.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_designer.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_designercomponents.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_gui.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_help.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_multimedia.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_multimediawidgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_network.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_opengl.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_openglextensions.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_platformsupport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_printsupport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qml.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qmldevtools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qmltest.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_qtmultimediaquicktools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_quick.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_quickparticles.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_script.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_scripttools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_sensors.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_serialport.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_sql.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_svg.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_testlib.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_uitools.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_v8.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_webkit.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_webkitwidgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_widgets.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_xml.pri C:/Qt/5.1.1/mingw48_32/mkspecs/modules/qt_lib_xmlpatterns.pri C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt_functions.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/win32-g++/qmake.conf C:/Qt/5.1.1/mingw48_32/mkspecs/features/spec_post.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/exclusive_builds.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/default_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/default_pre.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/resolve_config.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/default_post.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/build_pass.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qml_debug.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/declarative_debug.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/rtti.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/warn_on.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/qt.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/resources.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/moc.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/opengl.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/uic.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/win32/windows.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/testcase_targets.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/exceptions.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/yacc.prf C:/Qt/5.1.1/mingw48_32/mkspecs/features/lex.prf ../Untitled/Untitled.pro C:/Qt/5.1.1/mingw48_32/lib/Qt5Widgets.prl C:/Qt/5.1.1/mingw48_32/lib/Qt5Gui.prl C:/Qt/5.1.1/mingw48_32/lib/Qt5Core.prl  RESOURCES HEADERS SOURCES OBJECTIVE_SOURCES FORMS YACCSOURCES YACCSOURCES LEXSOURCES 
 
 clean: compiler_clean 
 	-$(DEL_FILE) release/main.o release/mainwindow.o release/moc_mainwindow.o
@@ -217,7 +217,7 @@
 		C:/Qt/5.1.1/mingw48_32/include/QtWidgets/qtabwidget.h \
 		C:/Qt/5.1.1/mingw48_32/include/QtGui/qicon.h \
 		../Untitled/mainwindow.h
-	@echo moc ../Untitled/mainwindow.h && C:/Qt/5.1.1/mingw48_32/bin/moc.exe $(DEFINES) -D__GNUC__ -DWIN32 $(INCPATH) ../Untitled/mainwindow.h -o release/moc_mainwindow.cpp
+	C:/Qt/5.1.1/mingw48_32/bin/moc.exe $(DEFINES) -D__GNUC__ -DWIN32 $(INCPATH) ../Untitled/mainwindow.h -o release/moc_mainwindow.cpp
 
 compiler_moc_source_make_all:
 compiler_moc_source_clean:
@@ -225,7 +225,7 @@
 compiler_uic_clean:
 	-$(DEL_FILE) ui_mainwindow.h
 ui_mainwindow.h: ../Untitled/mainwindow.ui
-	@echo uic ../Untitled/mainwindow.ui && C:/Qt/5.1.1/mingw48_32/bin/uic.exe ../Untitled/mainwindow.ui -o ui_mainwindow.h
+	C:/Qt/5.1.1/mingw48_32/bin/uic.exe ../Untitled/mainwindow.ui -o ui_mainwindow.h
 
 compiler_yacc_decl_make_all:
 compiler_yacc_decl_clean: